<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>
    <script src="utils.js"></script>

    <link rel="import" href="../dez-canvas.html">
  </head>
  <body>

    <test-fixture id="BadBgSrcTest">
        <template>
            <dez-canvas bg="bad/src"></dez-canvas>
        </template>
    </test-fixture>

    <test-fixture id="ChangedPropertyTestFixture">
      <template>
        <dez-canvas bg="../demo/magritte.jpg"></dez-canvas>
      </template>
    </test-fixture>

    <script>

    suite ('Bad background src tests', function () {

        setup (function () {
          this.timeout = 100;
          this.element = fixture('BadBgSrcTest');
        });

        test('setting the background with a bad src should not create a svg image', function (done) {
            setTimeout(function () {
                let imageElement = this.element.shadowRoot.querySelector('svg>image');
                assert.equal(imageElement, undefined);
                done();
            }.bind(this), this.timeout);
        });

        test('setting the background with a bad src should set default dimension', function (done) {
            setTimeout(function () {
                let svgElement = this.element.shadowRoot.querySelector('svg');
                assert.equal(svgElement.getAttribute("height"), '250');
                assert.equal(svgElement.getAttribute("width"), '500');
                assert.equal(svgElement.getAttribute("viewBox"), '0 0 500 250');
                done();
            }.bind(this), this.timeout);
        });

    });

    suite ('Background defined tests', function () {

        setup (function () {
            this.element = fixture('ChangedPropertyTestFixture');
        });

        test('setting the background should define the bg property', function () {
            assert.equal(this.element.bg, '../demo/magritte.jpg');
        });

        test('setting the background should change svg dimensions', function (done) {
            ensureImageIsLoaded(this.element, function (element) {
                let svgElement = element.shadowRoot.querySelector('svg');
                assert.equal(svgElement.getAttribute("height"), "350");
                assert.equal(svgElement.getAttribute("width"), '1000');
                assert.equal(svgElement.getAttribute("viewBox"), '0 0 1000 350');
                done();
            });
        });

        test('setting the background should add an svg image tag', function (done) {
            ensureImageIsLoaded(this.element, function (element) {
                var imageElement = element.shadowRoot.querySelector('svg>image');
                assert.equal(imageElement.nodeName, 'image');
                done();
            });
        });

        test('setting the background should add an svg image tag with the good src url', function (done) {
            ensureImageIsLoaded(this.element, function (element) {
                var imageElement = element.shadowRoot.querySelector('svg>image');
                assert.equal(imageElement.getAttribute("href"), '../demo/magritte.jpg');
                done();
            });
        });

        test('setting the background should add an svg image with good dimension', function (done) {
            ensureImageIsLoaded(this.element, function (element) {
                var imageElement = element.shadowRoot.querySelector('svg>image');
                assert.equal(imageElement.getAttribute("x"), '0');
                assert.equal(imageElement.getAttribute("y"), 25);
                assert.equal(imageElement.getAttribute("width"), '1000');
                assert.equal(imageElement.getAttribute("height"), '300');
                done();
            });
        });

    });

    </script>

  </body>
</html>
